<?php

if (!defined('BASEPATH'))
    exit('No direct script access allowed');

class Collaborator extends MX_Controller {

    public function __construct() {
        parent::__construct();
        $this->load->helper('cookie');
    }

    public function index() {
        $data = array();
        $admin_info = $this->session->userdata('adminInfo');
        if ($admin_info) {
            $data['content'] = $this->getCollaborators();
            $this->load->view('collaborator/index', $data);
        } else {
            $this->load->view('login');
        }
    }

    public function getCollaborators($filters = array()) {
        $this->load->helper('pagging');
        $this->load->model('collabolator_model');
        $data['current_page'] = $this->uri->segment(4, 1);
        $data['itemsoptions'] = array(10, 25, 50, 100);
        $data['perpage'] = 10;
        $data['keyword'] = "";
        $data['sorting_order']="sorting_desc";
        $data['sorting_field']="created_time";
        
        if ($this->input->post('sorting_order')) {
            if ($this->input->post('sorting_order') != "sorting")
            {
               $data['sorting_order']=$this->input->post('sorting_order');
               $data['sorting_field']=$this->input->post('sorting_field'); 
            }
        }
        if ($this->input->post('items')) {
            $data['perpage'] = $this->input->post('items');
        }
        if ($this->input->post('keyword')) {
            $data['search_field']="";
            $data['keyword'] = $this->input->post('keyword');
            $data['search_field']="cellphone";
            
            if (preg_match("/[0-9]/", $data['keyword']))
            {
               $data['search_field']="cellphone"; 
            }
            
        }
        
        $data['start'] = ($data['current_page'] - 1) * $data['perpage'];
        $data['total'] = $this->collabolator_model->countCollaborator($data);  
        $data['collaborators'] = $this->collabolator_model->getCollaborators($data);

        $data['paging_url'] = base_url() . "/admin/cong_tac_vien/trang/";
        $data['num_links'] = 2;
        $data['paging'] = pagging($data);

        if ($this->input->is_ajax_request()) {
            return $this->load->view('collaborator/listview', $data);
        }
        return $this->load->view('collaborator/listview', $data, true);
    }

    public function addCollaborator() {
        $result['success'] = 0;
        $result = array();
        $input = $this->input->post();
        $this->load->model('collabolator_model');
        if (strlen($input['full_name'])==0)
        {
            $result['errors'][]="Tên cộng tác viên không được để trống";
        }
        if (strlen($input['login_name'])==0)
        {
            $result['errors'][]="Tên đăng nhập không được để trống";
        }
        else
        {
            if ($this->collabolator_model->isExist(array('field'=>'login_name','value'=>$input['login_name'])))
            {
                $result['errors'][]="Tên đăng nhập đã được sử dụng";
            }
        }
        if (strlen($input['cellphone'])==0)
        {
            $result['errors'][]="Số điện thoại không được để trống";
        }
        else
        {
            if ($this->collabolator_model->isExist(array('field'=>'cellphone','value'=>$input['cellphone'])))
            {
                $result['errors'][]="Số điện thoại đã được sử dụng";
            }
        }
        if (strlen($input['passwd'])==0)
        {
            $result['errors'][]="Mật khẩu không được để trống";
        }
        if ($input['passwd'] != $input['passwd2'])
        {
            $result['errors'][]="Mật khẩu không trùng nhau";
        }
        if (!isset($result['errors']))
        {
            unset($input['passwd2']);
            $input['passwd']=md5($input['activated']);
            $input['activated']=1;
            $input['created_time']=date("Y-m-d H:i:s");
            $input['updated_time']=date("Y-m-d H:i:s");
            $this->load->model('collabolator_model');
            $this->collabolator_model->insert($input);
            $result['success'] = 1;
        }

        
        echo json_encode($result);
    }
    public function viewUser()
    {
        $id=$this->uri->segment(4);
        $this->load->model('collabolator_model');
        $data=$this->collabolator_model->getCollaborator($id);
        $this->load->view('collaborator/viewUser',$data);
    }
    public function editUser()
    {
        $id=$this->uri->segment(4);
        $this->load->model('collabolator_model');
        $data=$this->collabolator_model->getCollaborator($id);
        $this->load->view('collaborator/editUser',$data);
    }
    public function dodeleteUser()
    {
        $input=$this->input->post();
        $id=$input['id'];
        $this->load->model('collabolator_model');
        $data=$this->collabolator_model->delete($id);
        $result['success']=1;
        echo json_encode($result);
    }
    public function deleteUser()
    {
        $id=$this->uri->segment(4);
        $this->load->model('collabolator_model');
        $data=$this->collabolator_model->getCollaborator($id);
        $this->load->view('collaborator/deleteUser',$data);
    }
    public function updateUser()
    {
        $input['activated']=0;
        $input=  array_merge($input,$this->input->post());
        $this->load->model('collabolator_model');
        if (strlen($input['full_name'])==0)
        {
            $result['errors'][]="Tên cộng tác viên không được để trống";
        }
        if (strlen($input['login_name'])==0)
        {
            $result['errors'][]="Tên đăng nhập không được để trống";
        }
        else
        {
            if ($this->collabolator_model->isExist(array('field'=>'login_name','value'=>$input['login_name'],'id'=>$input['id'])))
            {
                $result['errors'][]="Tên đăng nhập đã được sử dụng";
            }
        }
        if (strlen($input['cellphone'])==0)
        {
            $result['errors'][]="Số điện thoại không được để trống";
        }
        else
        {
            if ($this->collabolator_model->isExist(array('field'=>'cellphone','value'=>$input['cellphone'],'id'=>$input['id'])))
            {
                $result['errors'][]="Số điện thoại đã được sử dụng";
            }
        }
        if (strlen($input['passwd'])==0)
        {
            //$result['errors'][]="Mật khẩu không được để trống";
        }
        if ($input['passwd'] != $input['passwd2'])
        {
            $result['errors'][]="Mật khẩu không trùng nhau";
        }
        if (!isset($result['errors']))
        {
            unset($input['passwd2']);
            $input['passwd']=md5($input['activated']);
            $input['updated_time']=date("Y-m-d H:i:s");
            $this->load->model('collabolator_model');
            $this->collabolator_model->update($input['id'],$input);
            $result['success'] = 1;
        }
        echo json_encode($result);
    }
    public function test() {
        
       
        for ($i = 1; $i <= 500; $i++) {
            $input['full_name']="Full Name ".$i;
            $input['login_name']="loginname".$i;
            $input['passwd']=md5("12345678");
            $input['cellphone']="01234567".(100+$i);
            $input['activated']=rand(0,1);
            $input['created_time']=date("Y-m-d H:i:s");
            $input['updated_time']=date("Y-m-d H:i:s");
            $this->load->model('collabolator_model');
            $this->collabolator_model->insert($input);
        }
        
        
    }

}
